package com.ruoyi.project.listener.semsApprove;



import com.alibaba.fastjson.JSON;
import com.github.stuxuhai.jpinyin.PinyinFormat;
import com.github.stuxuhai.jpinyin.PinyinHelper;
import com.ruoyi.common.sendEmail.IMailService;
import com.ruoyi.common.utils.SpringContextUtils;
import com.ruoyi.project.sems.domain.TApprove;
import com.ruoyi.project.sems.service.ITApproveService;
import com.ruoyi.project.system.service.ISysUserService;
import org.activiti.engine.delegate.DelegateTask;
import org.activiti.engine.delegate.TaskListener;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Date;


@Service("gyzjTaskCreateListener")
public class GyzjTaskCreateListener implements Serializable, TaskListener {
    protected Logger logger = LoggerFactory.getLogger(getClass());
    private static final long serialVersionUID = -375905405805540186L;


    @Override
    public void notify(DelegateTask delegateTask) {
        logger.info("Variables:" + JSON.toJSONString(delegateTask.getVariables()));
        String gyzjusers = (String) delegateTask.getVariables().get("gyzjusers");
        String id = delegateTask.getExecution().getProcessInstanceBusinessKey();
        ITApproveService tApproveService = (ITApproveService) SpringContextUtils.getBean("tApproveService");
        ISysUserService sysUserService = (ISysUserService) SpringContextUtils.getBean("sysUserService");
        IMailService mailService = (IMailService) SpringContextUtils.getBean("mailService");
        TApprove approveEntity = tApproveService.selectTApproveById(Long.parseLong(id)) ;
        logger.info("approveEntity:" + approveEntity);
        //发送邮件
        try {
            String email = sysUserService.selectUserById(Long.parseLong(gyzjusers)).getEmail();
            String apNo = approveEntity.getApNo();
            logger.info("apNo:" + apNo);
            String username = sysUserService.selectUserById(Long.parseLong(gyzjusers)).getNickName();
            String usernameEN = PinyinHelper.convertToPinyinString(username, " ", PinyinFormat.WITHOUT_TONE);
            logger.info("email:" + email);
            logger.info("username:" + username);
            String devType = "";
            String devTypeEN = "";
            switch (Integer.parseInt(approveEntity.getDevType().toString())) {
                case 1:
                    devType = "压力容器";
                    devTypeEN = "Pressure Vessel";
                    break;
                case 2:
                    devType = "压力管道";
                    devTypeEN = "Pressure Pipeline";
                    break;
                case 3:
                    devType = "起重机械";
                    devTypeEN = "Lifting Equipment";
                    break;
                case 4:
                    devType = "锅炉";
                    devTypeEN = "Boiler";
                    break;
                case 5:
                    devType = "电梯";
                    devTypeEN = "Elevator";
                    break;
                case 6:
                    devType = "叉车";
                    devTypeEN = "Forklift";
                    break;
                case 7:
                    devType = "常压罐";
                    devTypeEN = "Tank";
                    break;
            }
            String approveType = "";
            String approveTypeEN = "";
            switch (Integer.parseInt(approveEntity.getApproveType().toString())) {
                case 1:
                    approveType = "启用";
                    approveTypeEN = "Start Usage";
                    break;
                case 2:
                    approveType = "停用";
                    approveTypeEN = "Stop Usage";
                    break;
                case 3:
                    approveType = "报废";
                    approveTypeEN = "Scrapped";
                    break;
                case 4:
                    approveType = "改造";
                    approveTypeEN = "Retrofit";
                    break;
                case 5:
                    approveType = "延期检验";
                    approveTypeEN = "Deferred Inspection";
                    break;
                case 6:
                    approveType = "超设计寿命变更";
                    approveTypeEN = "Change Beyond Design Life";
                    break;
                case -1:
                    approveType = "注销";
                    approveTypeEN = "Logout";
                    break;
            }
            //写html开始内容
            String start = "<!DOCTYPE html><html><head><meta charset=\"utf-8\"><title></title></head><body><div style=\"background-color:#ECECEC; padding: 35px;\">" +
                    "<table cellpadding=\"0\" align=\"center\"" +
                    "style=\"width: 600px; margin: 0px auto; text-align: left; position: relative; border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; font-size: 14px; font-family:微软雅黑, 黑体; line-height: 1.5; box-shadow: rgb(153, 153, 153) 0px 0px 5px; border-collapse: collapse; background-position: initial initial; background-repeat: initial initial;background:#fff;\">" +
                    "<tbody><tr><th valign=\"middle\" style=\"height: 25px; line-height: 25px; padding: 15px 35px; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: #42a3d3; background-color: #49bcff; border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px;\">" +
                    "<font face=\"微软雅黑\" size=\"5\" style=\"color: rgb(255, 255, 255); \">特种设备信息管理系统 </font><font face=\"微软雅黑\" size=\"3\" style=\"color: rgb(255, 255, 255); \">Special Equipment Management System (SEMS)</font></th></tr>";
            //表html中间内容
            String prime = "";
            String center = "<tr><td><div style=\"padding:25px 35px 40px; background-color:#fff;\"><h2 style=\"margin: 5px 0px; \">" +
                    "<font color=\"#333333\" style=\"line-height: 20px; \"><font style=\"line-height: 22px; \" size=\"4\">" +
                    "亲爱的 username</font><br><font style=\"line-height: 22px; \" size=\"4\">" +
                    "Dear usernameEN</font></font></h2>" +
                    "<p>您有一个新的待办任务：<br>" +
                    "You have a new to-do task:<br>" +
                    "任务编号：<b>apNo</b><br>" +
                    "Task Number: <b>apNoEN</b><br>" +
                    "申请设备类型：<b>devType</b><br>" +
                    "Equipment Type: <b>devTypeEN</b><br>" +
                    "审批类型：<b>approveType</b><br>" +
                    "Application Category: <b>approveTypeEN</b><br>" +
                    "请登录<a href=\"https://cpms.basf-ypc.net.cn/cpms/index.html#/approve/pending\">特种设备信息管理系统</a>查看。<br>" +
                    "Please log in the <a href=\"https://cpms.basf-ypc.net.cn/cpms/index.html#/approve/pending\">SEMS</a> to handle it.</p>" +
                    "<p align=\"right\">date</p>" +
                    "<div style=\"width:700px;margin:0 auto;\">" +
                    "<div style=\"padding:10px 10px 0;border-top:1px solid #ccc;color:#747474;margin-bottom:20px;line-height:1.3em;font-size:12px;\">" +
                    "<p>此为系统邮件，请勿回复<br>This e-Mail is an automatic reminder sent by SEMS, please do not reply</p>" +
                    "</div></div></div></td></tr>";
            String one = center.replaceFirst("username", username);
            String two = one.replaceFirst("usernameEN", usernameEN);
            String three = two.replaceFirst("devType", devType);
            String four = three.replaceFirst("apNo", apNo);
            String five = four.replaceFirst("apNoEN", apNo);
            String six = five.replaceFirst("devTypeEN", devTypeEN);
            String seven = six.replaceFirst("approveType", approveType);
            String eight = seven.replaceFirst("approveTypeEN", approveTypeEN);
            String result = eight.replaceFirst("date", String.valueOf(new Date()));
            prime = prime + result;
            //写html结尾内容
            String end = "</tbody></table></div></body></html>";
            //拼接html
            String html = start + prime + end;
            logger.info("html:" + html);
            mailService.sendHtmlMail(email, "特种设备：您有一个新的待办任务 SEMS:You have a new to-do task (" + apNo + ")", html);
        }catch (Exception e) {
            logger.error("邮件发送失败" + JSON.toJSONString(e));
        }
    }
}
